/*
  Program: Vyhodnocova loh o poctivcch a padouch. 
  Autor: Radek Pelnek  
  Ploha ke knize "Jak to vyeit",  www.radekpelanek.cz/?jtv

  Zadn projektu: Napite program pro een loh o poctivcch a padouch.
  Vstupem programu je volba zadn lohy o poctivcch a padouch (samotn
  zadn lohy, tj. kdo co prohlsil, me bt zakdovan pmo v programu).
  Vstupem programu je pravdivostn tabulka vech monost a oznaen vech
  een lohy.
*/

#include <iostream>
#define MAX 10

using namespace std;


//vyrok muze byt 2 kdyz nic nerika

int n;
bool necorekl[MAX];
int osoba[MAX], vyrok[MAX];

/* Zadn loh:
  Dvojice (Albert a Bedich):
  1. Albert: "Alespo jeden z ns je padouch."
  2. Albert: "Oba dva jsme padoui."
  3. Albert: "Bedich je padouch." Bedich: "Kdepak, ani jeden z ns nen
      padouch."
  4. Albert: "Pokud je Bedich poctivec, tak j jsem padouch."
  
  Trojice (Albert, Bedich a Cyril):
  5. Albert: "Vichni jsme padoui." Bedich: "Prv jeden z ns je poctivec."
  6. Albert: "Vichni jsme padoui." Cyril: "Prv jeden z ns je padouch."
  7. Albert: "Bedich je poctivec." Bedich: "Pokud je Albert
      poctivec, pak je poctivec i Cyril."

*/

void nastaveni_ulohy(int uloha) {
  switch (uloha) {
  case 1: n = 2; necorekl[0] = true; necorekl[1] = false; break;
  case 2: n = 2; necorekl[0] = true; necorekl[1] = false; break;
  case 3: n = 2; necorekl[0] = true; necorekl[1] = true; break;
  case 4: n = 2; necorekl[0] = true; necorekl[1] = false; break;
  case 5: n = 3; necorekl[0] = true; necorekl[1] = true;  necorekl[2] = false; break;
  case 6: n = 3; necorekl[0] = true; necorekl[1] = false;  necorekl[2] = true; break;
  case 7: n = 3; necorekl[0] = true; necorekl[1] = true;  necorekl[2] = false; break;
  }
}

// Vyuv globln pole "osoba", kter uruje, kdo je poctivec a kdo padouch.
// Na zklad toho ulo do globlnho pole "vyrok" informaci, kter vroky jsou pravdiv.
void vyhodnoceni_akt_stavu(int uloha) {
  int poctivcu;
  
  switch (uloha) {
  case 1:
    vyrok[0] = (osoba[0]==false || osoba[1]==false);
    break;
  case 2:
    vyrok[0] = (osoba[0]==false && osoba[1]==false);
    break;
  case 3:
    vyrok[0] = (osoba[1]==false);
    vyrok[1] = (osoba[0]==true && osoba[1]==true);
    break;
  case 4:
    vyrok[0] = (osoba[1]==false || osoba[0]==false); 
    break;
  case 5:
    poctivcu = (osoba[0]==true?1:0) + (osoba[1]==true?1:0) + (osoba[2]==true?1:0);
    vyrok[0] = (poctivcu==0);
    vyrok[1] = (poctivcu==1);
    break;
  case 6:
    poctivcu = (osoba[0]==true?1:0) + (osoba[1]==true?1:0) + (osoba[2]==true?1:0);
    vyrok[0] = (poctivcu==0);
    vyrok[2] = (poctivcu==2);
    break;
  case 7:
    vyrok[0] = (osoba[1]==true);
    vyrok[1] = (osoba[0]==false || osoba[2]==true);
    break;
  }
}

//Vype tabulku pro zadanou lohu.
void vypis_tabulky(int uloha) {
  int i;
  
  cout << "Uloha "<<uloha<<endl;
  nastaveni_ulohy(uloha);

  for (i=0; i<n; i++) {
    char c = 65 + i;
    cout << c << "\t";
  }
  for (i=0; i<n; i++) {
    char c = 65 + i;
    if (necorekl[i]) cout << "V("<< c<< ")\t";
  }
  cout << endl;
  for (i=0; i<=n; i++)
    osoba[i] = false;

  while (osoba[n] == false) {
    bool reseni = true;
    vyhodnoceni_akt_stavu(uloha);
    for (i=0; i<n; i++)
      cout << osoba[i]<<"\t";
    for (i=0; i<n; i++)
      if (necorekl[i]) {
	cout << vyrok[i]<<"\t";
	if (osoba[i] != vyrok[i]) reseni = false;
      }
    if (reseni) cout << "reseni";
    cout <<endl;
    i=0;
    while (osoba[i]) {
      osoba[i] = false;
      i++;
    }
    osoba[i] = true;
  }
  cout <<endl;
}


int main() {

  int uloha;

  cout << "Sloupecek V(A) v tabulce znaci, zda vyrok, ktery pronesl A, je pravdivy."<<endl<<endl;
  
  for (uloha=1; uloha<=7; uloha++)
    vypis_tabulky(uloha);
  
  return 0;
}
